from System.Collections.Generic import List
#mining script by Mourn 8182 discord contact
#have a fire beetle and walk by mineable cliffs or caves , if necessary add ids on lines 4-5
mineableTiles = [0x023B,0x022C,0x023C,0x022D,0x022E,0x022F,0x00E4,0x00E6,0x00E5,0x00DC,0x00DE,0x00DD]#map art
mineableStatics = [0x053E,0x053B,0x0540,0x0541,0x0542,0x0543,0x0544,0x0555,0x0546,0x0547,0x0548,0x0549]#statics like cave tiles

#pathCoords = [[2562, 501],[2569, 505],[2576, 507],[2555, 501],[2557, 496],[2562, 493],[2561, 487],[2568, 487]]
 
miningCoords = [[-1,-1],[-1,0],[-1,1],[0,-1],[0,1],[1,-1],[1,0],[1,1],[-2,-2],[-2,2],[2,-2],[2,2]]

oreIDs = [0x19B7,0x19B8,0x19B9,0x19BA]
beetleID = List[int]((0x00A9,0x00A9))

fil = Mobiles.Filter()
fil.Enabled = True
fil.RangeMax = 25
fil.Bodies = beetleID
        
def go(x1, y1):
    Coords = PathFinding.Route()
    Coords.X = x1
    Coords.Y = y1
    Coords.MaxRetry = 10
    PathFinding.Go(Coords)
    Misc.Pause(400)
      
def checkTile(x,y):
    global count
    x1 = Player.Position.X+x
    y1 = Player.Position.Y+y
    z1 = Statics.GetLandZ(x1,y1,Player.Map) 
    tile = Statics.GetLandID(x1,y1,Player.Map)
    statics = Statics.GetStaticsTileInfo(x1,y1,Player.Map)
    if statics:
        for static in statics:
            if static.StaticID in mineableStatics:
                Misc.SendMessage('in a cave')
                id = static.StaticID
                mineTile(x1,y1,Player.Position.Z)
    if not statics:
        if tile in mineableTiles:
            mineTile(x1,y1,z1)

def mineTile(x,y,z):
    while Items.BackpackCount(0x0E86) > 58:
        if Journal.Search('metal') or Journal.Search('see'):
            Journal.Clear()
            break            
        Items.UseItemByID(0x0E86)
        Target.WaitForTarget(1000,False)
        Target.TargetExecute(x,y,z)
        Misc.Pause(1000)
        if Player.Weight > Player.MaxWeight -45:
            smelt()
            
def smelt():    
    beetles = Mobiles.ApplyFilter(fil)
    beetle = Mobiles.Select(beetles,'Nearest')
    if Player.InRangeMobile(beetle,2):
        for item in Player.Backpack.Contains:
            if item.ItemID in oreIDs:
                Items.UseItem(item)
                Target.WaitForTarget(1000,False)
                Target.TargetExecute(beetle)
                Misc.Pause(1000)
        
def Main():
    while not Player.IsGhost:
        #for pcoords in pathCoords:
            # go(pcoords[0],pcoords[1])
            for mcoords in miningCoords:
                checkTile(mcoords[0],mcoords[1])
            Misc.Pause(200)
       
        
Main()